#!/bin/bash

bleu="\033[01;34m"
rouge="\033[01;31m"
vert="\033[01;32m"
blanc="\033[01;37m"

# Ce script a pour but d'automatiser les opérations suivantes :

# J'ai un programme C qui sera $1.c,
# je veux :
# date && gcc -O3 -lm -o $1 $1.c && date && ./$1

zenityP="0"

if [ "$1" = "-Z" ]
then
	zenityP="1"
	shift
fi

nom_programme="$1"

echo -e "${vert}***************************************************************************************************************************${blanc}"
# echo -e "Vous avez demandé a exécuter le script $0 avec $1 comme argument. Bonne journée !"

#Vérifie que le fichier demandé existe bien dans le répertoire courant :
if [ ! -f $nom_programme.c ]
then
	echo -e "${rouge}Le fichier $1.c demandé n'existe pas.$blanc Désolé !"
	exit 1
fi

echo -e "Ce script va compiler le fichier ${bleu}$1.c$blanc, puis va l'exécuter.	Lilian BESSON 2012 − ENS de Cachan & LSV & CMLA"

#Compile
#echo -e "La compilation va commencer..."
date "+La compilation -O3 va commencer... il est %Hh:%Mm:%Ss..."
time gcc -O3 -lm -o $nom_programme $nom_programme.c -lm
echo -e "${vert}La compilation -O3 est terminée !$blanc"

shift

#Exécute
#echo -e "L'exécution va commencer..."
date "+L'exécution va commencer... il est %Hh:%Mm:%Ss..."
#date
echo ""
time ./$nom_programme $*
echo ""
echo -e "${vert}L'exécution s'est bien passée.$blanc	Bonne journée !"

sortie_verif=`~/verification_nan.sh`
echo "$sortie_verif"

if [ ! -d "VTK/" ]; then
	mkdir VTK/
fi

mv *.vtk VTK/

if [ "$zenityP" = "1" ]
then
	textZenity="Calcul bien terminé ?\n$sortie_verif"
	zenity --info --title="AUTO gcc : $nom_programme" --window-icon="/home/besson/elfe-menu.gif" --text="$textZenity"
fi

exit 0

#C'est fini.

echo -e "${vert}***************************************************************************************************************************${blanc}"
#
#	Ecrit par Lilian BESSON
#		Ens de Cachan & LSV & CMLA
#			© Naereen Corp. 2012
#
