#!/bin/bash

bleu="\033[01;34m"
rouge="\033[01;31m"
vert="\033[01;32m"
blanc="\033[01;37m"

# Ce script a pour but d'automatiser les opérations suivantes :

# J'ai un programme CUDA qui sera $1.cu,
# je veux :
# date && nvcc -lGL -lm -lglut -o $1 $1.cu && date && ./$1

zenityP="0"

if [ "$1" = "-Z" ]
then
	zenityP="1"
	shift
fi

code_cu="$1"
shift
liste_arg="$*"

echo -e "${vert}***************************************************************************************************************************${blanc}"
# echo -e "Vous avez demandé a exécuter le script $0 avec $code_cu [et $liste_args] comme argument. Bonne journée !"

#Vérifie que le fichier demandé existe bien dans le répertoire courant :
if [ ! -f "$code_cu.cu" ]
then
	echo -e "${rouge}Le fichier $code_cu.cu demandé n'existe pas.$blanc Désolé !"
	exit 1
fi

echo -e "Ce script va compiler le fichier ${bleu}$code_cu.cu$blanc, puis va l'exécuter.	Lilian BESSON 2012 − ENS de Cachan & LSV & CMLA"

#Compile
#echo -e "La compilation va commencer..."
date "+La compilation va commencer... il est %Hh:%Mm:%Ss..."
time nvcc  -I/home/besson/NVIDIA_GPU_Computing_SDK/shared/inc/ -I/home/besson/NVIDIA_GPU_Computing_SDK/C/common/inc  -I/home/besson/NVIDIA_GPU_Computing_SDK/CUDA/common/inc  -I/usr/local/cuda/include -lcuda -lcudart -L/home/besson/NVIDIA_GPU_Computing_SDK/shared/lib/linux  -L/home/besson/NVIDIA_GPU_Computing_SDK/C/common/lib/linux -L/home/besson/NVIDIA_GPU_Computing_SDK/CUDA/common/lib/linux -lGLEW_x86_64 -lcublas -lGL -lm -lglut -o "$code_cu" "$code_cu.cu"
echo -e "${vert}La compilation est terminée !$blanc"

if [ "$1" = "-n" ]
then
		echo "Pas d'execution : option -n ou code non produit [Erreur ?]"
		if [ ! -f "$code_cu" ]
		then
			echo "${rouge}ERREUR : code non produit$blanc"
			exit 1
		fi
else
		echo -e "Test d'existence de $code_cu"
		if [ ! -f "$code_cu" ]
		then
			echo "${rouge}ERREUR : code non produit$blanc"
			exit 1
		fi
		# On élimine les deux arguments: autonvcc <code>
		#shift
		#shift
		echo "Arguments = $liste_arg"

		#Exécute
		#echo -e "L'exécution va commencer..."
		date "+L'exécution va commencer... il est %Hh:%Mm:%Ss..."
		#date
		echo ""

		./$code_cu $liste_arg

		if [ "$?" =  "0" ]
		then
			echo -e "\n${vert}L'exécution s'est bien passée.${blanc}	Bonne journée !"
		fi
		sortie_verif=`~/verification_nan.sh`
		echo "$sortie_verif"
		if [ ! -d "VTK/" ]; then
			mkdir VTK/
		fi
		mv *.vtk VTK/
fi

if [ "$zenityP" = "1" ]
then
	textZenity="Calcul bien terminé ?\n$sortie_verif"
	zenity --info --title="AUTO nvcc : $code_cu" --window-icon="/home/besson/elfe-menu.gif" --text="$textZenity"
fi

exit 0

echo -e "${vert}***************************************************************************************************************************${blanc}"
#C'est fini.
